;                   === RT2.LSP ===
;by Trevor Bousfield - modified by Colin Browning
;            *** CAD User Vol 3 No 5 ***
(defun C:RT2 ()
(graphscr)
(setvar "cmdecho" 0)
(initget 1)
(setq LL (Getpoint "Please enter the centre of text rotation: "))
(command "UCS" "o" LL)
(initget (+ 1 2 4))
(setq n (getreal  "\nplease enter the number of characters: "))
(initget (+ 1 2 4))
(setq h (getdist "\nPlease enter the text height: "))
(setq r (/ (/ h 2) (sin (/ pi n))))
(setq x 0 y r c t a 0)
(setq p1 (list x y))
(while c
 (setq w h)
 (setq s (getstring "Enter a character or <Enter> to terminate: "))
 (if (eq s "I") (setq w (* 0.5 h)))
 (if (eq s "")(setq c nil))
 (setq a1 (* (+ a (/ (* 0.5 w) r)) (- 0 1) 57.296))
 (command "text" p1 h a1 s)
 (setq a (+ a (/ w r)))
 (setq x (* r (sin a)))
 (setq y (* r (cos a)))
 (setq p1 (list x y))
)
(command "UCS" "p")
(setvar "cmdecho" 1)
(princ)
)
