;                    === TR3.LSP ===
;by Trevor Bousfield  *** CAD User Vol 3 No 5 ***
(defun C:RT3 ()
(graphscr)
(setvar "cmdecho" 0)
(initget 1)
(setq LL (Getpoint "Please enter the centre for elliptical text rotation: "))
(command "UCS" "o" LL)
(initget (+ 1 2 4))
(setq r (getreal "\nPlease enter the minimum radius of ellipse: "))
(initget (+ 1 2 4))
(setq h (getdist "\nPlease enter the text height: "))
(setq ra (getreal "\nPlease enter the axis ratio of ellipse: "))
(setq x 0 y (* ra r) c t a 0)
(setq p1 (list x y))
(while c
(setq w h)
 (setq s (getstring "\nEnter a character or <Enter> to terminate: "))
 (if (eq s "I") (setq w (* 0.5 h)))
 (if (eq s "")(setq c nil))
 (setq a (+ a (/ w r)))
 (setq x (* r (sin a)))
 (setq y (* r ra (cos a)))
 (setq p2 (list x y))
 (setq a2 (angle p1 p2))
 (setq a1 (* a2 57.296))
 (command "text" p1 h a1 s)
 (setq p1 p2)
)
(command "UCS" "p")
(setvar "cmdecho" 1)
(princ)
)