;                  === SYMBINS.LSP ===
;This routine inserts a symbol onto a line. Symbols used must be 
;the same overall length (ie 10 units) as the line is automatically 
;trimmed to accommodate the symbol.       Written by Colin Browning 
;              *** CAD User Vol 2 No 2 ***
;
(Defun C:SYMBINS (/ P1 P2 N ANG1 ANG2)
(graphscr)
(setvar "osmode" 512)
(Setq P1 (getpoint "Pick symbol insertion point: "))
(Setq P2 (getpoint "\nPick 2nd point to fix angle: "))
(setvar "osmode" 0)
(Setq N (getstring "\nEnter name of symbol: "))
(Setq ANG1 (angle P1 P2))
(Setq ANG2 (* ANG1 (/ 180.0 pi)))
(Setq P2 (POLAR P1 ANG1 10))
(setvar "CMDECHO" 0)
(Command "BREAK" P1 P2)
(Command "INSERT" N P1 "1" "1" ANG2)
(princ)
)
